Index: LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2298)
@@ -29,6 +29,4 @@
 
 ! Declaration of variables saved in restart file
-  REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE     :: qsol   ! water height in the soil (mm)
-  !$OMP THREADPRIVATE(qsol)
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE     :: fder   ! flux drift
   !$OMP THREADPRIVATE(fder)
@@ -37,11 +35,4 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: qsurf  ! humidity at surface
   !$OMP THREADPRIVATE(qsurf)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: evap   ! evaporation at surface
-  !$OMP THREADPRIVATE(evap)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: rugos  ! rugosity at surface (m)
-  !$OMP THREADPRIVATE(rugos)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: agesno ! age of snow at surface
-  !$OMP THREADPRIVATE(agesno)
-! Correction pour le cas AMMA (PRIVATE)
   REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE :: ftsoil ! soil temperature
   !$OMP THREADPRIVATE(ftsoil)
@@ -51,6 +42,5 @@
 !****************************************************************************************
 !
-  SUBROUTINE pbl_surface_init(qsol_rst, fder_rst, snow_rst, qsurf_rst,&
-       evap_rst, rugos_rst, agesno_rst, ftsoil_rst)
+  SUBROUTINE pbl_surface_init(fder_rst, snow_rst, qsurf_rst, ftsoil_rst)
 
 ! This routine should be called after the restart file has been read.
@@ -65,11 +55,7 @@
 ! Input variables
 !****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(IN)                 :: qsol_rst
     REAL, DIMENSION(klon), INTENT(IN)                 :: fder_rst
     REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: snow_rst
     REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: qsurf_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: evap_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: rugos_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(IN)          :: agesno_rst
     REAL, DIMENSION(klon, nsoilmx, nbsrf), INTENT(IN) :: ftsoil_rst
 
@@ -86,7 +72,4 @@
 !
 !****************************************************************************************    
-    ALLOCATE(qsol(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
-
     ALLOCATE(fder(klon), stat=ierr)
     IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
@@ -98,24 +81,11 @@
     IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
 
-    ALLOCATE(evap(klon,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
-
-    ALLOCATE(rugos(klon,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
-
-    ALLOCATE(agesno(klon,nbsrf), stat=ierr)
-    IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
-
     ALLOCATE(ftsoil(klon,nsoilmx,nbsrf), stat=ierr)
     IF (ierr /= 0) CALL abort_gcm('pbl_surface_init', 'pb in allocation',1)
 
 
-    qsol(:)       = qsol_rst(:)
     fder(:)       = fder_rst(:)
     snow(:,:)     = snow_rst(:,:)
     qsurf(:,:)    = qsurf_rst(:,:)
-    evap(:,:)     = evap_rst(:,:)
-    rugos(:,:)    = rugos_rst(:,:)
-    agesno(:,:)   = agesno_rst(:,:)
     ftsoil(:,:,:) = ftsoil_rst(:,:,:)
 
@@ -174,4 +144,5 @@
        zsig,      lwdown_m,  pphi,     cldt,          &
        rain_f,    snow_f,    solsw_m,  sollw_m,       &
+       gustiness,                                     &
        t,         q,         u,        v,             &
 !!! nrlmd+jyg le 02/05/2011 et le 20/02/2012
@@ -181,13 +152,7 @@
 !!!
        pplay,     paprs,     pctsrf,                  &
-!albedo SB >>>
-!       ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
        ts,SFRWL,   alb_dir, alb_dif,ustar, u10m, v10m,wstar, &
-!albedo SB <<<
        cdragh,    cdragm,   zu1,    zv1,              &
-!albedo SB >>>
-!       alb1_m,    alb2_m,    zxsens,   zxevap,        &
        alb_dir_m,    alb_dif_m,  zxsens,   zxevap,    &
-!albedo SB <<<
        alb3_lic,  runoff,    snowhgt,   qsnow,     to_ice,    sissnow,  &
        zxtsol,    zxfluxlat, zt2m,     qsat2m,        &
@@ -204,5 +169,5 @@
 !!!
        zcoefh,    zcoefm,    slab_wfbils,             &
-       qsol_d,    zq2m,      s_pblh,   s_plcl,        &
+       qsol,    zq2m,      s_pblh,   s_plcl,        &
 !!!
 !!! jyg le 08/02/2012
@@ -211,8 +176,8 @@
        s_capCL,   s_oliqCL,  s_cteiCL, s_pblT,        &
        s_therm,   s_trmb1,   s_trmb2,  s_trmb3,       &
-       zxrugs,zustar,zu10m,  zv10m,    fder_print,    &
+       zustar,zu10m,  zv10m,    fder_print,    &
        zxqsurf,   rh2m,      zxfluxu,  zxfluxv,       &
-       rugos_d,   agesno_d,  sollw,    solsw,         &
-       d_ts,      evap_d,    fluxlat,  t2m,           &
+       z0m, z0h,   agesno,  sollw,    solsw,         &
+       d_ts,      evap,    fluxlat,  t2m,           &
        wfbils,    wfbilo,    flux_t,   flux_u, flux_v,&
        dflux_t,   dflux_q,   zxsnow,                  &
@@ -263,5 +228,5 @@
 ! pplay----input-R- pression au milieu de couche (Pa)
 ! rlat-----input-R- latitude en degree
-! rugos----input-R- longeur de rugosite (en m)
+! z0m, z0h ----input-R- longeur de rugosite (en m)
 ! Martin
 ! zsig-----input-R- slope
@@ -334,4 +299,6 @@
     REAL, DIMENSION(klon),        INTENT(IN)        :: zsig    ! slope
     REAL, DIMENSION(klon),        INTENT(IN)        :: lwdown_m ! downward longwave radiation at mean s    
+    REAL, DIMENSION(klon),        INTENT(IN)        :: gustiness ! gustiness
+
     REAL, DIMENSION(klon),        INTENT(IN)        :: cldt    ! total cloud fraction
     REAL, DIMENSION(klon,klev),   INTENT(IN)        :: pphi    ! geopotential (m2/s2)
@@ -356,6 +323,4 @@
                                                                    !wake and off-wake regions
 !albedo SB >>>
-!    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb1    ! albedo in visible SW interval
-!    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb2    ! albedo in near infra-red SW interval
     REAL, DIMENSIOn(6),intent(in) :: SFRWL
     REAL, DIMENSION(klon, nsw, nbsrf), INTENT(INOUT)     :: alb_dir,alb_dif
@@ -382,8 +347,4 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zv1        ! v wind speed in first layer
 !albedo SB >>>
-!    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb1_m     ! mean albedo
-!    in visible SW interval
-!    REAL, DIMENSION(klon),        INTENT(OUT)       :: alb2_m     ! mean albedo
-!    in near IR SW interval
     REAL, DIMENSION(klon, nsw),        INTENT(OUT)       :: alb_dir_m,alb_dif_m
 !albedo SB <<<
@@ -434,5 +395,5 @@
 !!! 
     REAL, DIMENSION(klon),        INTENT(OUT)       :: slab_wfbils! heat balance at surface only for slab at ocean points
-    REAL, DIMENSION(klon),        INTENT(OUT)       :: qsol_d     ! water height in the soil (mm)
+    REAL, DIMENSION(klon),        INTENT(OUT)       :: qsol     ! water height in the soil (mm)
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zq2m       ! water vapour at 2m, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_pblh     ! height of the planetary boundary layer(HPBL)
@@ -454,5 +415,4 @@
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_trmb2    ! inhibition, mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: s_trmb3    ! point Omega, mean for each grid point
-    REAL, DIMENSION(klon),        INTENT(OUT)       :: zxrugs     ! rugosity at surface (m), mean for each grid point
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zustar     ! u*
     REAL, DIMENSION(klon),        INTENT(OUT)       :: zu10m      ! u speed at 10m, mean for each grid point
@@ -463,10 +423,10 @@
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zxfluxu    ! u wind tension, mean for each grid point
     REAL, DIMENSION(klon, klev),  INTENT(OUT)       :: zxfluxv    ! v wind tension, mean for each grid point
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: rugos_d    ! rugosity length (m)
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: agesno_d   ! age of snow at surface
+    REAL, DIMENSION(klon, nbsrf+1), INTENT(INOUT)     :: z0m,z0h      ! rugosity length (m)
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)       :: agesno   ! age of snow at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: solsw      ! net shortwave radiation at surface 
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: sollw      ! net longwave radiation at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: d_ts       ! change in temperature at surface
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: evap_d     ! evaporation at surface
+    REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)       :: evap     ! evaporation at surface
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: fluxlat    ! latent flux
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)       :: t2m        ! temperature at 2 meter height
@@ -519,7 +479,6 @@
     REAL                               :: f1 ! fraction de longeurs visibles parmi tout SW intervalle
     REAL, DIMENSION(klon)              :: r_co2_ppm     ! taux CO2 atmosphere
-    REAL, DIMENSION(klon)              :: yts, yrugos, ypct, yz0_new
+    REAL, DIMENSION(klon)              :: yts, yz0m, yz0h, ypct
 !albedo SB >>>
-!   REAL, DIMENSION(klon)              :: yalb, yalb1, yalb2
     REAL, DIMENSION(klon)              :: yalb,yalb_vis
 !albedo SB <<<
@@ -559,5 +518,5 @@
     REAL, DIMENSION(klon)              :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon)              :: ypsref
-    REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb1_new, yalb2_new, yalb3_new
+    REAL, DIMENSION(klon)              :: yevap, ytsurf_new, yalb3_new
 !albedo SB >>>
     REAL, DIMENSION(klon,nsw)          :: yalb_dir_new, yalb_dif_new
@@ -795,4 +754,5 @@
     REAL, DIMENSION(klon, nbsrf)       :: alb          ! mean albedo for whole SW interval
     REAL, DIMENSION(klon)              :: ylwdown      ! jg : temporary (ysollwdown)
+    REAL, DIMENSION(klon)              :: ygustiness      ! jg : temporary (ysollwdown)
 
     REAL                               :: zx_qs1, zcor1, zdelta1 
@@ -823,4 +783,5 @@
 
     IF (first_call) THEN
+       print*,'PBL SURFACE AVEC GUSTINESS'
        first_call=.FALSE.
       
@@ -877,5 +838,4 @@
  zu1(:)=0. ; zv1(:)=0.
 !albedo SB >>>
-! alb1_m(:)=0. ; alb2_m(:)=0. ; alb3_lic(:)=0.
   alb_dir_m=0. ; alb_dif_m=0. ; alb3_lic(:)=0.
 !albedo SB <<<
@@ -890,5 +850,4 @@
  kh(:)=0. ; kh_x(:)=0. ; kh_w(:)=0.
  slab_wfbils(:)=0.
- qsol_d(:)=0.
  s_pblh(:)=0. ; s_pblh_x(:)=0. ; s_pblh_w(:)=0.
  s_plcl(:)=0. ; s_plcl_x(:)=0. ; s_plcl_w(:)=0.
@@ -896,13 +855,12 @@
  s_therm(:)=0.
  s_trmb1(:)=0. ; s_trmb2(:)=0. ; s_trmb3(:)=0.
- zxrugs(:)=0. ; zustar(:)=0.
+ zustar(:)=0.
  zu10m(:)=0. ; zv10m(:)=0.
  fder_print(:)=0.
  zxqsurf(:)=0.
  zxfluxu(:,:)=0. ; zxfluxv(:,:)=0.
- rugos_d(:,:)=0. ; agesno_d(:,:)=0.
  solsw(:,:)=0. ; sollw(:,:)=0.
  d_ts(:,:)=0.
- evap_d(:,:)=0.
+ evap(:,:)=0.
  fluxlat(:,:)=0.
  wfbils(:,:)=0. ; wfbilo(:,:)=0.
@@ -943,11 +901,10 @@
 !!    cdragh = 0.0  ; cdragm = 0.0     ; dflux_t = 0.0   ; dflux_q = 0.0
     ypct = 0.0    ; yts = 0.0        ; ysnow = 0.0
-!!    zv1 = 0.0     ; yqsurf = 0.0     ; yalb1 = 0.0     ; yalb2 = 0.0    
+!!    zv1 = 0.0     ; yqsurf = 0.0
 !albedo SB >>>
-!    yqsurf = 0.0  ; yalb1 = 0.0      ; yalb2 = 0.0    
     yqsurf = 0.0  ; yalb = 0.0 ; yalb_vis = 0.0
 !albedo SB <<<
     yrain_f = 0.0 ; ysnow_f = 0.0    ; yfder = 0.0     ; ysolsw = 0.0    
-    ysollw = 0.0  ; yrugos = 0.0     ; yu1 = 0.0    
+    ysollw = 0.0  ; yz0m = 0.0 ; yz0h = 0.0    ; yu1 = 0.0    
     yv1 = 0.0     ; ypaprs = 0.0     ; ypplay = 0.0
     ydelp = 0.0   ; yu = 0.0         ; yv = 0.0        ; yt = 0.0         
@@ -1077,9 +1034,8 @@
 !****************************************************************************************
 
-    zxrugs(:) = 0.0
     DO nsrf = 1, nbsrf
        DO i = 1, klon
-          rugos(i,nsrf) = MAX(rugos(i,nsrf),0.000015)
-          zxrugs(i) = zxrugs(i) + rugos(i,nsrf)*pctsrf(i,nsrf)
+          z0m(i,nsrf) = MAX(z0m(i,nsrf),z0min)
+          z0h(i,nsrf) = MAX(z0h(i,nsrf),z0min)
        ENDDO
     ENDDO
@@ -1087,23 +1043,8 @@
 ! Mean calculations of albedo
 !
-! Albedo at sub-surface
-! * alb1 : albedo in visible SW interval
-! * alb2 : albedo in near infrared SW interval
 ! * alb  : mean albedo for whole SW interval
 !
 ! Mean albedo for grid point
-! * alb1_m : albedo in visible SW interval
-! * alb2_m : albedo in near infrared SW interval
 ! * alb_m  : mean albedo at whole SW interval
-
-!albedo SB >>>
-!    alb1_m(:) = 0.0
-!    alb2_m(:) = 0.0
-!    DO nsrf = 1, nbsrf
-!       DO i = 1, klon
-!          alb1_m(i) = alb1_m(i) + alb1(i,nsrf) * pctsrf(i,nsrf)
-!          alb2_m(i) = alb2_m(i) + alb2(i,nsrf) * pctsrf(i,nsrf)
-!       ENDDO
-!    ENDDO
 
     alb_dir_m(:,:) = 0.0
@@ -1123,15 +1064,4 @@
 !    f1 = 1    ! put f1=1 to recreate old calculations
 
-!    DO nsrf = 1, nbsrf
-!       DO i = 1, klon
-!          alb(i,nsrf) = f1*alb1(i,nsrf) + (1-f1)*alb2(i,nsrf)
-!       ENDDO
-!    ENDDO
-!
-!    DO i = 1, klon
-!       alb_m(i) = f1*alb1_m(i) + (1-f1)*alb2_m(i)
-!    END DO
-
-
 !f1 is already included with SFRWL values in each surf files
     alb=0.0
@@ -1177,5 +1107,4 @@
        ENDDO
     ENDDO
-
 
 !****************************************************************************************
@@ -1231,6 +1160,4 @@
           yalb(j)    = alb(i,nsrf)
 !albedo SB >>>
-!         yalb1(j)   = alb1(i,nsrf)
-!         yalb2(j)   = alb2(i,nsrf)
           yalb_vis(j) = alb_dir(i,1,nsrf)
           if(nsw==6)then
@@ -1244,7 +1171,9 @@
           yfder(j)   = fder(i)
           ylwdown(j) = lwdown_m(i)
+          ygustiness(j) = gustiness(i)
           ysolsw(j)  = solsw(i,nsrf)
           ysollw(j)  = sollw(i,nsrf)
-          yrugos(j)  = rugos(i,nsrf)
+          yz0m(j)  = z0m(i,nsrf)
+          yz0h(j)  = z0h(i,nsrf)
           yrugoro(j) = rugoro(i)
           yu1(j)     = u(i,1)
@@ -1377,5 +1306,5 @@
         CALL cdrag(knon, nsrf, &
             speed, yt(:,1), yq(:,1), zgeo1, ypaprs(:,1),&
-            yts, yqsurf, yrugos, &
+            yts, yqsurf, yz0m, yz0h, &
             ycdragm, ycdragh, zri1, pref )
 
@@ -1408,5 +1337,5 @@
         CALL cdrag(knon, nsrf, &
             speed_x, yt_x(:,1), yq_x(:,1), zgeo1_x, ypaprs(:,1),&
-            yts_x, yqsurf, yrugos, &
+            yts_x, yqsurf, yz0m, yz0h, &
             ycdragm_x, ycdragh_x, zri1_x, pref_x )
 
@@ -1422,8 +1351,20 @@
         IF (prt_level >=10) print *,'clcdrag -> ycdragh_x ', ycdragh_x
 !
-        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
-            yu_w(:,1), yv_w(:,1), yt_w(:,1), yq_w(:,1), &
-            yts_w, yqsurf, yrugos, &
-            ycdragm_w, ycdragh_w )
+! Faire disparaitre les lignes commentees fin 2015 (le temps des tests)
+!        CALL clcdrag( knon, nsrf, ypaprs, ypplay, &
+!            yu_w(:,1), yv_w(:,1), yt_w(:,1), yq_w(:,1), &
+!            yts_w, yqsurf, yz0m, &
+!            ycdragm_w, ycdragh_w )
+! Fuxing WANG, 04/03/2015, replace the clcdrag by the merged version: cdrag
+        DO i = 1, knon
+           zgeo1_w(i) = RD * yt_w(i,1) / (0.5*(ypaprs(i,1)+ypplay(i,1))) &
+                * (ypaprs(i,1)-ypplay(i,1))
+           speed_w(i) = SQRT(yu_w(i,1)**2+yv_w(i,1)**2)
+        END DO
+        CALL cdrag(knon, nsrf, &
+            speed_w, yt_w(:,1), yq_w(:,1), zgeo1_w, ypaprs(:,1),&
+            yts_w, yqsurf, yz0m, yz0h, &
+            ycdragm_w, ycdragh_w, zri1_w, pref_w )
+
 ! --- special Dice. JYG+MPL 25112013
         IF (ok_prescr_ust) then
@@ -1456,5 +1397,5 @@
       print *,' args coef_diff_turb: yt ',  yt  
       print *,' args coef_diff_turb: yts ', yts  
-      print *,' args coef_diff_turb: yrugos ', yrugos  
+      print *,' args coef_diff_turb: yz0m ', yz0m  
       print *,' args coef_diff_turb: yqsurf ', yqsurf  
       print *,' args coef_diff_turb: ycdragm ', ycdragm
@@ -1463,5 +1404,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf, ycdragm, &
+            ypaprs, ypplay, yu, yv, yq, yt, yts, yqsurf, ycdragm, &
             ycoefm, ycoefh, ytke)
        IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
@@ -1484,5 +1425,4 @@
       print *,' args coef_diff_turb: yt_x ',  yt_x  
       print *,' args coef_diff_turb: yts_x ', yts_x  
-      print *,' args coef_diff_turb: yrugos ', yrugos  
       print *,' args coef_diff_turb: yqsurf ', yqsurf  
       print *,' args coef_diff_turb: ycdragm_x ', ycdragm_x
@@ -1491,5 +1431,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yrugos, yqsurf, ycdragm_x, &
+            ypaprs, ypplay, yu_x, yv_x, yq_x, yt_x, yts_x, yqsurf, ycdragm_x, &
             ycoefm_x, ycoefh_x, ytke_x)
        IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
@@ -1511,5 +1451,4 @@
       print *,' args coef_diff_turb: yt_w ',  yt_w  
       print *,' args coef_diff_turb: yts_w ', yts_w  
-      print *,' args coef_diff_turb: yrugos ', yrugos  
       print *,' args coef_diff_turb: yqsurf ', yqsurf  
       print *,' args coef_diff_turb: ycdragm_w ', ycdragm_w
@@ -1518,5 +1457,5 @@
        ENDIF
         CALL coef_diff_turb(dtime, nsrf, knon, ni,  &
-            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yrugos, yqsurf, ycdragm_w, &
+            ypaprs, ypplay, yu_w, yv_w, yq_w, yt_w, yts_w, yqsurf, ycdragm_w, &
             ycoefm_w, ycoefh_w, ytke_w)
        IF (iflag_pbl>=20.AND.iflag_pbl<30) THEN
@@ -1779,5 +1718,5 @@
           CALL stdlevvar(klon, knon, is_ter, zxli, &
                yu(:,1), yv(:,1), yt(:,1), yq(:,1), zgeo1, &
-               yts, yqsurf, yrugos, ypaprs(:,1), ypplay(:,1), &
+               yts, yqsurf, yz0m, yz0h, ypaprs(:,1), ypplay(:,1), &
                yt2m, yq2m, yt10m, yq10m, yu10m, yustar)
           
@@ -1801,11 +1740,8 @@
                AcoefH, AcoefQ, BcoefH, BcoefQ, & 
                AcoefU, AcoefV, BcoefU, BcoefV, & 
-               ypsref, yu1, yv1, yrugoro, pctsrf, &
+               ypsref, yu1, yv1, ygustiness, yrugoro, pctsrf, &
                ylwdown, yq2m, yt2m, &
                ysnow, yqsol, yagesno, ytsoil, &
-!albedo SB >>>
-!              yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
-!albedo SB <<<
+               yz0m, yz0h, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
                yqsurf, ytsurf_new, y_dflux_t, y_dflux_q, &
                y_flux_u1, y_flux_v1 )
@@ -1818,6 +1754,4 @@
 !         ytsoil(:,:)=300.
 !         yz0_new(:)=0.001
-!         yalb1_new(:)=0.22
-!         yalb2_new(:)=0.22
 !         yevap(:)=flat/RLVTT
 !         yfluxlat(:)=-flat
@@ -1841,10 +1775,7 @@
                AcoefH, AcoefQ, BcoefH, BcoefQ, &
                AcoefU, AcoefV, BcoefU, BcoefV, &
-               ypsref, yu1, yv1, yrugoro, pctsrf, &
+               ypsref, yu1, yv1, ygustiness, yrugoro, pctsrf, &
                ysnow, yqsurf, yqsol, yagesno, &
-!albedo SB >>>
-!              ytsoil, yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               ytsoil, yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap,yfluxsens,yfluxlat, &
-!albedo SB <<<
+               ytsoil, yz0m, yz0h, SFRWL, yalb_dir_new, yalb_dif_new, yevap,yfluxsens,yfluxlat, &
                ytsurf_new, y_dflux_t, y_dflux_q, &
                yzsig, ycldt, &
@@ -1852,14 +1783,4 @@
                yalb3_new, yrunoff, &
                y_flux_u1, y_flux_v1)
-          !CALL surf_landice(itap, dtime, knon, ni, &
-          !     ysolsw, ysollw, yts, ypplay(:,1), &
-          !     ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
-          !     AcoefH, AcoefQ, BcoefH, BcoefQ, &
-          !     AcoefU, AcoefV, BcoefU, BcoefV, &
-          !     ypsref, yu1, yv1, yrugoro, pctsrf, &
-          !     ysnow, yqsurf, yqsol, yagesno, &
-          !     ytsoil, yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-          !     ytsurf_new, y_dflux_t, y_dflux_q, &
-          !     y_flux_u1, y_flux_v1)
 
 !jyg<
@@ -1878,19 +1799,13 @@
           
        CASE(is_oce)
-!albedo SB >>>
-!          CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb1, &
            CALL surf_ocean(rlon, rlat, ysolsw, ysollw, yalb_vis, &
-!albedo SB <<<
-               yrugos, ywindsp, rmu0, yfder, yts, &
+               ywindsp, rmu0, yfder, yts, &
                itap, dtime, jour, knon, ni, &
-               ypplay(:,1), ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
+               ypplay(:,1), zgeo1/RG, ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
                AcoefH, AcoefQ, BcoefH, BcoefQ, &
                AcoefU, AcoefV, BcoefU, BcoefV, &
-               ypsref, yu1, yv1, yrugoro, pctsrf, &
+               ypsref, yu1, yv1, ygustiness, yrugoro, pctsrf, &
                ysnow, yqsurf, yagesno, &
-!albedo SB >>>
-!              yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               yz0_new, SFRWL,yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
-!albedo SB <<<
+               yz0m, yz0h, SFRWL,yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
                ytsurf_new, y_dflux_t, y_dflux_q, slab_wfbils, &
                y_flux_u1, y_flux_v1)
@@ -1914,5 +1829,4 @@
           CALL surf_seaice( &
 !albedo SB >>>
-!               rlon, rlat, ysolsw, ysollw, yalb1, yfder, &
                rlon, rlat, ysolsw, ysollw, yalb_vis, yfder, &
 !albedo SB <<<
@@ -1922,9 +1836,8 @@
                AcoefH, AcoefQ, BcoefH, BcoefQ, &
                AcoefU, AcoefV, BcoefU, BcoefV, &
-               ypsref, yu1, yv1, yrugoro, pctsrf, &
+               ypsref, yu1, yv1, ygustiness, pctsrf, &
                ysnow, yqsurf, yqsol, yagesno, ytsoil, &
 !albedo SB >>>
-!               yz0_new, yalb1_new, yalb2_new, yevap, yfluxsens, yfluxlat, &
-               yz0_new, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
+               yz0m, yz0h, SFRWL, yalb_dir_new, yalb_dif_new, yevap, yfluxsens,yfluxlat,&
 !albedo SB <<<
                ytsurf_new, y_dflux_t, y_dflux_q, &
@@ -2298,6 +2211,4 @@
           d_ts(i,nsrf) = y_d_ts(j)
 !albedo SB >>>
-!          alb1(i,nsrf) = yalb1_new(j)  
-!          alb2(i,nsrf) = yalb2_new(j)
           do k=1,nsw
           alb_dir(i,k,nsrf) = yalb_dir_new(j,k)
@@ -2307,5 +2218,6 @@
           snow(i,nsrf) = ysnow(j)  
           qsurf(i,nsrf) = yqsurf(j)
-          rugos(i,nsrf) = yz0_new(j)
+          z0m(i,nsrf) = yz0m(j)
+          z0h(i,nsrf) = yz0h(j)
           fluxlat(i,nsrf) = yfluxlat(j)
           agesno(i,nsrf) = yagesno(j)  
@@ -2519,7 +2431,7 @@
        DO j=1, knon
           i = ni(j)
-          rugo1(j) = yrugos(j)
+          rugo1(j) = yz0m(j)
           IF(nsrf.EQ.is_oce) THEN
-             rugo1(j) = rugos(i,nsrf)
+             rugo1(j) = z0m(i,nsrf)
           ENDIF
           psfce(j)=ypaprs(j,1)
@@ -2536,14 +2448,14 @@
         CALL stdlevvar(klon, knon, nsrf, zxli, &
             uzon, vmer, tair1, qair1, zgeo1, &
-            tairsol, qairsol, rugo1, psfce, patm, &
+            tairsol, qairsol, rugo1, rugo1, psfce, patm, &
             yt2m, yq2m, yt10m, yq10m, yu10m, yustar)
        ELSE  !(iflag_split .eq.0)
         CALL stdlevvar(klon, knon, nsrf, zxli, &
             uzon_x, vmer_x, tair1_x, qair1_x, zgeo1_x, &
-            tairsol_x, qairsol, rugo1, psfce, patm, &
+            tairsol_x, qairsol, rugo1, rugo1, psfce, patm, &
             yt2m_x, yq2m_x, yt10m_x, yq10m_x, yu10m_x, yustar_x)
         CALL stdlevvar(klon, knon, nsrf, zxli, &
             uzon_w, vmer_w, tair1_w, qair1_w, zgeo1_w, &
-            tairsol_w, qairsol, rugo1, psfce, patm, &
+            tairsol_w, qairsol, rugo1, rugo1, psfce, patm, &
             yt2m_w, yq2m_w, yt10m_w, yq10m_w, yu10m_w, yustar_w)
 !!!
@@ -2771,4 +2683,13 @@
 !****************************************************************************************
     
+    z0m(:,nbsrf+1) = 0.0
+    z0h(:,nbsrf+1) = 0.0
+    DO nsrf = 1, nbsrf
+       DO i = 1, klon
+          z0m(i,nbsrf+1) = z0m(i,nbsrf+1) + z0m(i,nsrf)*pctsrf(i,nsrf)
+          z0h(i,nbsrf+1) = z0h(i,nbsrf+1) + z0h(i,nsrf)*pctsrf(i,nsrf)
+       ENDDO
+    ENDDO
+
 !   print*,'OK pbl 7'
     zxfluxt(:,:) = 0.0 ; zxfluxq(:,:) = 0.0
@@ -2987,10 +2908,4 @@
     zv1(:) = v(:,1)
 
-! Some of the module declared variables are returned for printing in physiq.F
-    qsol_d(:)     = qsol(:)
-    evap_d(:,:)   = evap(:,:)
-    rugos_d(:,:)  = rugos(:,:) 
-    agesno_d(:,:) = agesno(:,:)
-
 
   END SUBROUTINE pbl_surface
@@ -2998,6 +2913,5 @@
 !****************************************************************************************
 !
-  SUBROUTINE pbl_surface_final(qsol_rst, fder_rst, snow_rst, qsurf_rst, &
-       evap_rst, rugos_rst, agesno_rst, ftsoil_rst)
+  SUBROUTINE pbl_surface_final(fder_rst, snow_rst, qsurf_rst, ftsoil_rst)
 
     USE indice_sol_mod
@@ -3007,11 +2921,7 @@
 ! Ouput variables
 !****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(OUT)                 :: qsol_rst
     REAL, DIMENSION(klon), INTENT(OUT)                 :: fder_rst
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)          :: snow_rst
     REAL, DIMENSION(klon, nbsrf), INTENT(OUT)          :: qsurf_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)          :: evap_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)          :: rugos_rst
-    REAL, DIMENSION(klon, nbsrf), INTENT(OUT)          :: agesno_rst
     REAL, DIMENSION(klon, nsoilmx, nbsrf), INTENT(OUT) :: ftsoil_rst
 
@@ -3021,11 +2931,7 @@
 !
 !****************************************************************************************    
-    qsol_rst(:)       = qsol(:)
     fder_rst(:)       = fder(:)
     snow_rst(:,:)     = snow(:,:)
     qsurf_rst(:,:)    = qsurf(:,:)
-    evap_rst(:,:)     = evap(:,:)
-    rugos_rst(:,:)    = rugos(:,:)
-    agesno_rst(:,:)   = agesno(:,:)
     ftsoil_rst(:,:,:) = ftsoil(:,:,:)
 
@@ -3035,11 +2941,7 @@
 !****************************************************************************************
 !   DEALLOCATE(qsol, fder, snow, qsurf, evap, rugos, agesno, ftsoil)
-    IF (ALLOCATED(qsol)) DEALLOCATE(qsol)
     IF (ALLOCATED(fder)) DEALLOCATE(fder)
     IF (ALLOCATED(snow)) DEALLOCATE(snow)
     IF (ALLOCATED(qsurf)) DEALLOCATE(qsurf)
-    IF (ALLOCATED(evap)) DEALLOCATE(evap)
-    IF (ALLOCATED(rugos)) DEALLOCATE(rugos)
-    IF (ALLOCATED(agesno)) DEALLOCATE(agesno)
     IF (ALLOCATED(ftsoil)) DEALLOCATE(ftsoil)
 
@@ -3050,6 +2952,7 @@
 
 !albedo SB >>>
-!  SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf, alb1, alb2, ustar, u10m, v10m, tke)
-SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, tsurf,alb_dir,alb_dif, ustar, u10m, v10m, tke)  
+SUBROUTINE pbl_surface_newfrac(itime, pctsrf_new, pctsrf_old, &
+     evap, z0m, z0h, agesno,                                  &
+     tsurf,alb_dir,alb_dif, ustar, u10m, v10m, tke)  
 !albedo SB <<<
     ! Give default values where new fraction has appread
@@ -3070,9 +2973,10 @@
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: tsurf
 !albedo SB >>>
-!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: alb1, alb2
     REAL, DIMENSION(klon,nsw,nbsrf), INTENT(INOUT)       :: alb_dir, alb_dif 
     INTEGER :: k
 !albedo SB <<<
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: ustar,u10m, v10m
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT)        :: evap, agesno
+    REAL, DIMENSION(klon,nbsrf+1), INTENT(INOUT)        :: z0m,z0h
     REAL, DIMENSION(klon,klev+1,nbsrf+1), INTENT(INOUT) :: tke
 
@@ -3116,9 +3020,8 @@
                 qsurf(i,nsrf) = qsurf(i,nsrf_comp1)
                 evap(i,nsrf)  = evap(i,nsrf_comp1)
-                rugos(i,nsrf) = rugos(i,nsrf_comp1)
+                z0m(i,nsrf) = z0m(i,nsrf_comp1)
+                z0h(i,nsrf) = z0h(i,nsrf_comp1)
                 tsurf(i,nsrf) = tsurf(i,nsrf_comp1)
 !albedo SB >>>
-!                alb1(i,nsrf)  = alb1(i,nsrf_comp1)
-!                alb2(i,nsrf)  = alb2(i,nsrf_comp1)
                 DO k=1,nsw
                  alb_dir(i,k,nsrf)=alb_dir(i,k,nsrf_comp1)
@@ -3137,9 +3040,8 @@
                 qsurf(i,nsrf) = qsurf(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + qsurf(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
                 evap(i,nsrf)  = evap(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + evap(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
-                rugos(i,nsrf) = rugos(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + rugos(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                z0m(i,nsrf) = z0m(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + z0m(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
+                z0h(i,nsrf) = z0h(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + z0h(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
                 tsurf(i,nsrf) = tsurf(i,nsrf_comp2)*pctsrf_old(i,nsrf_comp2) + tsurf(i,nsrf_comp3)*pctsrf_old(i,nsrf_comp3)
 !albedo SB >>>
-!                alb1(i,nsrf)  = alb1(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb1(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
-!                alb2(i,nsrf)  = alb2(i,nsrf_comp2) *pctsrf_old(i,nsrf_comp2) + alb2(i,nsrf_comp3) *pctsrf_old(i,nsrf_comp3)
                 DO k=1,nsw
                  alb_dir(i,k,nsrf)=alb_dir(i,k,nsrf_comp2)*pctsrf_old(i,nsrf_comp2)+&
Index: LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2298)
@@ -48,9 +48,7 @@
     REAL :: run_off_lic_0(nlon)
     REAL :: qsolsrf(nlon, nbsrf), snsrf(nlon, nbsrf)
-    REAL :: frugs(nlon, nbsrf)
-    REAL :: agesno(nlon, nbsrf)
     REAL :: tsoil(nlon, nsoilmx, nbsrf)
     REAL :: tslab(nlon), seaice(nlon)
-    REAL evap(nlon, nbsrf), fder(nlon)
+    REAL fder(nlon)
 
 
@@ -67,5 +65,5 @@
     REAL tsurf
     REAL time, timestep, day, day0
-    REAL qsol_f, qsol(nlon)
+    REAL qsol_f
     REAL rugsrel(nlon)
     ! real zmea(nlon),zstd(nlon),zsig(nlon)
@@ -328,5 +326,5 @@
     seaice(:) = 0.
     run_off_lic_0 = 0.
-    evap = 0.
+    fevap = 0.
 
 
@@ -336,9 +334,9 @@
     qsolsrf(:, :) = qsol(1) ! humidite du sol des sous surface
     snsrf(:, :) = 0. ! couverture de neige des sous surface
-    frugs(:, :) = rugos ! couverture de neige des sous surface
-
-
-    CALL pbl_surface_init(qsol, fder, snsrf, qsolsrf, evap, frugs, agesno, &
-      tsoil)
+    z0m(:, :) = rugos ! couverture de neige des sous surface
+    z0h=z0m
+
+
+    CALL pbl_surface_init(fder, snsrf, qsolsrf, tsoil)
 
     PRINT *, 'iniaqua: before phyredem'
